#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char* find_char(char* s, char c) {
    int i = 0;
    while (s[i] != '\0') {
        if (s[i] == c)
            return s + i; // &s[i]
        else
            i++;
    }
    return NULL;
}

char* find_str(char* s1, char* s2) {
    int i = 0;
    while (s1[i] != '\0') {

        int ind = 1;
        int j = 0;
        while (s2[j] != '\0' && s1[i + j] != '\0') {
            if (s1[i + j] != s2[j]) {
                ind = 0;
                break;
            }
            j++;
        }

        if (ind)
            return s1 + i; // &s1[i]
        else
            i++;
    }
    return NULL;
}

void to_upper(char* s) {
    int i = 0;
    while (s[i] != '\0') {
        if ('a' <= s[i] && s[i] <= 'z') {
            s[i] = s[i] - 'a' + 'A';
        }
        i++;
    }
}

void to_lower(char* s) {
    int i = 0;
    while (s[i] != '\0') {
        if ('A' <= s[i] && s[i] <= 'Z') {
            s[i] = s[i] - 'A' + 'a';
        }
        i++;
    }
}

void compress(char* s1, char* s2) {
    int j = 0;

    int i = 0;
    while (s1[i] != '\0') {

        s2[j] = s1[i];
        j++;

        int cnt = 1;
        while (s1[i] == s1[i+1]) {
            cnt++;
            i++;
        }

        s2[j] = '0' + cnt;
        j++;

        i++;
    }

    s2[j] = '\0';
}

void compress2(char* s1, char* s2) {
    s2[0] = '\0';
    char pom[10];

    int i = 0;
    while (s1[i] != '\0') {

        int cnt = 1;
        while (s1[i] == s1[i+1]) {
            cnt++;
            i++;
        }

        sprintf(pom, "%c", s1[i]);
        strcat(s2, pom);

        sprintf(pom, "%d", cnt);
        strcat(s2, pom);

        i++;
    }
}

/// za vjezbu inverzna operacija (decompress): a3b4c5 -> aaabbbbccccc

int palindrom(char* s) {
    int n = strlen(s);
    int i;
    for (i = 0; i < n/2; i++) {
        if (s[i] != s[n-1-i])
            return 0;
    }
    return 1;
}

void najduzi_palindrom(char* s) {
    int n = strlen(s);
    int k;
    char pom[100];

    for (k = n; k > 0; k--) {
        int i;
        for (i = 0; i <= n-k; i++) {
            strncpy(pom, s+i, k);
            pom[k] = '\0';
            if (palindrom(pom)) {
                puts(pom);
                return;
            }
        }
    }
}

int main()
{
    char s1[100] = "abcd";
    char s2[100] = "xyz123";

    char c = 'a';
    char* c_ptr = strchr(s1, c);
    printf("%p %c\n", c_ptr, *c_ptr);
    c_ptr = find_char(s1, c);
    printf("%p %c\n", c_ptr, *c_ptr);

    char s3[100] = "z12";
    c_ptr = strstr(s2, s3); // na slajdovima pogresan poredak argumenata
    printf("%p\n", c_ptr);
    c_ptr = find_str(s2, s3);
    printf("%p\n", c_ptr);
    printf("%d\n", strlen(s3));

    char s4[100] = "principi programiranja AB";
    char* token = strtok(s4, " ");
    //printf("%p %p\n", s4, token);
    while (token != NULL) {
        puts(token);
        token = strtok(NULL, " ");
    }

    char s5[100] = "principi programiranja AB";
    //to_upper(s5);
    to_lower(s5);
    puts(s5);

    printf("%d %c\n", 'e'-'a'+'A', 'e'-'a'+'A');

    char s6[100] = "aaaaaaaaaa"; // "aaabbbbccccc";
    char s7[100];
    compress2(s6, s7);
    puts(s7);

    int cnt[26] = {0};
    char s8[100] = "programiranje";
    int i = 0;
    while (s8[i] != '\0') {
        cnt[s8[i] - 'a']++;
        i++;
    }
    int j;
    printf("\n");
    for (j = 0; j < 26; j++) {
        if (cnt[j] > 0)
            printf("%c: %d\n", 'a' + j, cnt[j]);
    }
    printf("\n");

    /// za vjezbu provjera jesu li data dva stringa anagrami

    najduzi_palindrom("abcdcbxyz");

    return 0;
}
